-- Public Domain 
-- by http://notsure.co.cc

-- Beginning code of a racing game. Controls: left, right, up, down.

function love.load()

	screenWidth = love.graphics.getWidth()
	screenHeight = love.graphics.getHeight()
	frontPoint = { screenWidth / 2, screenHeight / 2 }
	rightPoint = { frontPoint[1] + 30, frontPoint[1] - 30 }
	leftPoint = { frontPoint[1] - 30, frontPoint[1] - 30 }
	stretchThin = frontPoint[2] + 105
	stretchThick = frontPoint[2] + 69
	rightSide = { }
	leftSide = { }
	
end
--
--
function love.keypressed(key)

	if key == "escape" then
		love.event.push("quit") 
	end

end
--
--
function love.update(dt)

	if  frontPoint[1] > screenWidth - 30 then -- side detection
		-- reset the racer to the center
		frontPoint[1] = screenWidth - 40
		leftPoint[1], leftPoint[2] = frontPoint[1] - 30, frontPoint[2] + 60
		rightPoint[1], rightPoint[2] = frontPoint[1] + 30, frontPoint[2] + 60
	end
	
	if frontPoint[1] < 30 then -- side detection
		-- reset the racer to the center
		frontPoint[1] = 40
		leftPoint[1], leftPoint[2] = frontPoint[1] - 30, frontPoint[2] + 60
		rightPoint[1], rightPoint[2] = frontPoint[1] + 30, frontPoint[2] + 60
	end
	
	if leftPoint[2] < rightPoint[2] then -- moves racer left
		-- move all points at the same time/direction
		frontPoint[1] = frontPoint[1] - 0.1 * (rightPoint[2] - leftPoint[2])
		leftPoint[1] = leftPoint[1]  - 0.1 * (rightPoint[2] - leftPoint[2])
		rightPoint[1] = rightPoint[1]  - 0.1 * (rightPoint[2] - leftPoint[2])
	elseif rightPoint[2] < leftPoint[2] then -- moves racer right
		-- move all points at the same time/direction
		frontPoint[1] = frontPoint[1] + 0.1 * (leftPoint[2] - rightPoint[2])
		leftPoint[1] = leftPoint[1]  + 0.1 * (leftPoint[2] - rightPoint[2])
		rightPoint[1] = rightPoint[1]  + 0.1 * (leftPoint[2] - rightPoint[2])
	else
		-- axis points are equal. Stay still
	end

	if love.keyboard.isDown("up") then --accerates the racer
		if leftPoint[2] > stretchThin or rightPoint[2] > stretchThin then
			return -- lock the distance racer can morph away from front point
		else
			rightPoint[1], rightPoint[2] = rightPoint[1] - 1, rightPoint[2] + 2
			leftPoint[1], leftPoint[2] = leftPoint[1] + 1, leftPoint[2] + 2
		end
	end

	if love.keyboard.isDown("down") then -- slows down the racer
		if leftPoint[2] < stretchThick or rightPoint[2] < stretchThick then
			return -- lock the distance racer can morph towards from front point
		else
			rightPoint[1], rightPoint[2] = rightPoint[1] + 1, rightPoint[2] - 2
			leftPoint[1], leftPoint[2] = leftPoint[1] - 1, leftPoint[2] - 2
		end
	end

	if love.keyboard.isDown("left") then
		-- steers the racer
		if rightPoint[2] > stretchThin + 1 then -- limits the y axis movement
			return
		else
			leftPoint[1], leftPoint[2] = leftPoint[1] - 1, leftPoint[2] - 2
			rightPoint[1], rightPoint[2] = rightPoint[1] - 1, rightPoint[2] + 2
		end
	end

	if love.keyboard.isDown("right") then
		-- steers the racer
		if leftPoint[2] > stretchThin + 1 then -- limits the y axis movement
			return
		else
			rightPoint[1], rightPoint[2] = rightPoint[1] + 1, rightPoint[2] - 2
			leftPoint[1], leftPoint[2] = leftPoint[1] + 1, leftPoint[2] + 2
		end
	end
			
end
--  
--  
function love.draw()
 	verticies = { frontPoint[1], frontPoint[2], rightPoint[1], rightPoint[2], leftPoint[1], leftPoint[2] }
	love.graphics.polygon('fill', verticies)
	--love.graphics.print("Front:"..tostring(frontPoint[1])..":"..tostring(frontPoint[2]), frontPoint[1] - 35, frontPoint[2] - 15)
	--love.graphics.print("R:"..tostring(rightPoint[1])..":"..tostring(rightPoint[2]), rightPoint[1] - 35, rightPoint[2] + 3)
	--love.graphics.print("L:"..tostring(leftPoint[1])..":"..tostring(leftPoint[2]), leftPoint[1] - 35, leftPoint[2] + 3)
	--love.graphics.print("Front: "..tostring(frontPoint[1]).." : "..tostring(frontPoint[2]), 10, 0)
	--love.graphics.print("Right: "..tostring(rightPoint[1]).." : "..tostring(rightPoint[2]), 10, 20)
	--love.graphics.print("Left:  "..tostring(leftPoint[1]).." : "..tostring(leftPoint[2]), 10, 40)

end

